<?php

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_enqueue')){
    function ifwp_enqueue($handle = '', $src = '', $deps = [], $ver = false, $in_footer = true){
		$mimes = [
			'css' => 'text/css',
			'js' => 'application/javascript',
		];
		$filetype = wp_check_filetype(ifwp_basename($src), $mimes);
		switch($filetype['type']){
			case 'application/javascript':
				wp_enqueue_script($handle, $src, $deps, $ver, $in_footer);
				break;
			case 'text/css':
				wp_enqueue_style($handle, $src, $deps, $ver);
				break;
			default:
				return ifwp_error(__('Sorry, you are not allowed to upload this file type.')); // __('Sorry, this file type is not permitted for security reasons.')
		}
		return true;
    }
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_enqueue_stylesheet')){
    function ifwp_enqueue_stylesheet(){
		ifwp_one('wp_enqueue_scripts', function(){
            wp_enqueue_style(get_stylesheet(), get_stylesheet_uri(), [], filemtime(get_stylesheet_directory() . '/style.css'));
        });
    }
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
