<?php

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_off')){
    function ifwp_off($hook_name = '', $callback = '', $priority = 10){
        return remove_filter($hook_name, $callback, $priority);
    }
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_on')){
    function ifwp_on($hook_name = '', $callback = '', $priority = 10, $accepted_args = 1){
        add_filter($hook_name, $callback, $priority, $accepted_args);
        return _wp_filter_build_unique_id($hook_name, $callback, $priority);
    }
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_one')){
    function ifwp_one($hook_name = '', $callback = '', $priority = 10, $accepted_args = 1){
        if(!array_key_exists($hook_name, IFWP::$hooks)){
            IFWP::$hooks[$hook_name] = [];
        }
        $idx = _wp_filter_build_unique_id($hook_name, $callback, $priority);
        $md5 = md5($idx);
        if($callback instanceof Closure){
            $md5_closure = ifwp_md5_closure($callback);
            if(!is_wp_error($md5_closure)){
                $md5 = $md5_closure;
            }
        }
        if(array_key_exists($md5, IFWP::$hooks[$hook_name])){
            return IFWP::$hooks[$hook_name][$md5];
        } else {
            IFWP::$hooks[$hook_name][$md5] = $idx;
            add_filter($hook_name, $callback, $priority, $accepted_args);
            return $idx;
        }
    }
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
