<?php

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_jwt_decode')){
    function ifwp_jwt_decode(...$args){
        if(!class_exists('Firebase\JWT\JWT')){
            $dir = ifwp_remote_lib('https://github.com/firebase/php-jwt/archive/refs/tags/v5.5.1.zip', 'php-jwt-5.5.1');
            if(is_wp_error($dir)){
                return $dir;
            }
            require_once($dir . '/src/BeforeValidException.php');
            require_once($dir . '/src/ExpiredException.php');
            require_once($dir . '/src/JWK.php');
            require_once($dir . '/src/JWT.php');
            require_once($dir . '/src/SignatureInvalidException.php');
        }
        return Firebase\JWT\JWT::decode(...$args);
    }
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_jwt_encode')){
    function ifwp_jwt_encode(...$args){
        if(!class_exists('Firebase\JWT\JWT')){
            $dir = ifwp_remote_lib('https://github.com/firebase/php-jwt/archive/refs/tags/v5.5.1.zip', 'php-jwt-5.5.1');
            if(is_wp_error($dir)){
                return $dir;
            }
            require_once($dir . '/src/BeforeValidException.php');
            require_once($dir . '/src/ExpiredException.php');
            require_once($dir . '/src/JWK.php');
            require_once($dir . '/src/JWT.php');
            require_once($dir . '/src/SignatureInvalidException.php');
        }
        return Firebase\JWT\JWT::encode(...$args);
    }
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
