<?php

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_md5')){
    function ifwp_md5($data = ''){
        if(is_object($data)){
            if($data instanceof Closure){
                return ifwp_md5_closure($data);
            } else {
                $data = wp_json_encode($data);
                $data = json_decode($data, true);
            }
        }
        if(is_array($data)){
            $data = ifwp_ksort_deep($data);
            $data = maybe_serialize($data);
        }
        return md5($data);
    }
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_md5_closure')){
    function ifwp_md5_closure($data = null, $spl_object_hash = false){
        if($data instanceof Closure){
            $wrapper = ifwp_serializable_closure($data);
            if(is_wp_error($wrapper)){
                return $wrapper;
            }
            $serialized = maybe_serialize($wrapper);
            if(!$spl_object_hash){
                $spl_object_hash = spl_object_hash($data);
                $serialized = str_replace($spl_object_hash, 'ifwp_spl_object_hash', $serialized);
            }
            return md5($serialized);
        } else {
            return ifwp_error(__('Invalid object type.'));
        }
    }
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_md5_to_uuid4')){
    function ifwp_md5_to_uuid4($md5 = ''){
        if(32 !== strlen($md5)){
            return '';
        }
        return substr($md5, 0, 8) . '-' . substr($md5, 8, 4) . '-' . substr($md5, 12, 4) . '-' . substr($md5, 16, 4) . '-' . substr($md5, 20, 12);
    }
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
