<?php

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_add_external_rule')){
    function ifwp_add_external_rule($regex = '', $query = ''){
		$rule = [
			'query' => str_replace(home_url('/'), '', $query),
            'regex' => str_replace(home_url('/'), '', $regex),
		];
		$md5 = ifwp_md5($rule);
		IFWP::$external_rules[$md5] = $rule;
		ifwp_one('admin_init', function(){
            if(!current_user_can('manage_options')){
                return;
            }
            $add_admin_notice = false;
            foreach(IFWP::$external_rules as $rule){
                if(!ifwp_external_rule_exists($rule['regex'], $rule['query'])){
                    $add_admin_notice = true;
                    break;
                }
            }
            if($add_admin_notice){
                ifwp_add_admin_notice(sprintf(__('You should update your %s file now.'), '<code>.htaccess</code>') . ' ' . sprintf('<a href="%s">%s</a>', esc_url(admin_url('options-permalink.php')), __('Flush permalinks')) . '.');
            }
		});
		ifwp_one('generate_rewrite_rules', function($wp_rewrite){
			if(!ifwp_is_plugin_deactivating()){
				foreach(IFWP::$external_rules as $rule){
					$wp_rewrite->add_external_rule($rule['regex'], $rule['query']);
				}
			}
		});
    }
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_external_rule_exists')){
    function ifwp_external_rule_exists($regex = '', $query = ''){
		if(!IFWP::$rewrite_rules){
			IFWP::$rewrite_rules = array_filter(extract_from_markers(get_home_path() . '.htaccess', 'WordPress'));
		}
    	$regex = str_replace('.+?', '.+', $regex); // Apache 1.3 does not support the reluctant (non-greedy) modifier.
    	$rule = 'RewriteRule ^' . $regex . ' ' . ifwp_home_root() . $query . ' [QSA,L]';
    	return in_array($rule, IFWP::$rewrite_rules);
    }
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_home_root')){
    function ifwp_home_root(){
        $home_root = parse_url(home_url());
    	if(isset($home_root['path'])){
    		$home_root = trailingslashit($home_root['path']);
    	} else {
    		$home_root = '/';
    	}
    	return $home_root;
    }
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
