<?php

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_get_current_utm_params')){
    function ifwp_get_current_utm_params(){
		$params = [];
		foreach(ifwp_get_utm_params() as $param){
            // 1. GET, 2. COOKIE
            if(isset($_GET['utm_' . $param]) and $_GET['utm_' . $param]){ // cookie will be set
                $params[$param] = $_GET['utm_' . $param];
            } elseif(isset($_COOKIE['utm_' . $param . '_' . COOKIEHASH])){
				$params[$param] = $_COOKIE['utm_' . $param . '_' . COOKIEHASH];
			} else {
				$params[$param] = ''; // fix
			}
		}
		return $params;
	}
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_get_utm_params')){
    function ifwp_get_utm_params($keys = true){
		$params = [
			'campaign' => 'Campaign',
			'content' => 'Content',
			'id' => 'ID',
			'medium' => 'Medium',
			'source' => 'Source',
			'term' => 'Term',
		];
		if($keys){
			return array_keys($params);
		}
		return $params;
	}
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_maybe_set_utm_params_cookies')){
    function ifwp_maybe_set_utm_params_cookies(){
		$at_least_one = false;
		$cookie_lifetime = time() + (14 * DAY_IN_SECONDS);
		$params = ifwp_get_utm_params();
		$secure = ('https' === parse_url(home_url(), PHP_URL_SCHEME));
		foreach($params as $param){
			if(isset($_GET['utm_' . $param])){
				$at_least_one = true;
				break;
			}
		}
		if(!$at_least_one){
			return;
		}
		ifwp_maybe_unset_utm_params_cookies();
		foreach($params as $param){
			if(isset($_GET['utm_' . $param])){
				$value = $_GET['utm_' . $param];
				if($value){
					$value = wp_unslash($value);
					$value = esc_attr($value);
					setcookie('utm_' . $param . '_' . COOKIEHASH, $value, $cookie_lifetime, COOKIEPATH, COOKIE_DOMAIN, $secure);
				}
			}
		}
	}
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(!function_exists('ifwp_maybe_unset_utm_params_cookies')){
    function ifwp_maybe_unset_utm_params_cookies(){
		$past = time() - YEAR_IN_SECONDS;
		foreach(ifwp_get_utm_params() as $param){
			if(isset($_COOKIE['utm_' . $param . '_' . COOKIEHASH])){
				setcookie('utm_' . $param . '_' . COOKIEHASH, ' ', $past, COOKIEPATH, COOKIE_DOMAIN);
			}
		}
	}
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
