<?php
/*
Author: IFWP
Author URI: https://ifwp.co
Description: Improvements and Fixes for WordPress.
Domain Path:
License: GPL2
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Network: true
Plugin Name: IFWP
Plugin URI: https://plugins.ifwp.co
Requires at least: 5.6
Requires PHP: 5.6
Text Domain: ifwp
Version: 2.3.5
*/

if(!defined('ABSPATH')){
    die('Hi there! I\'m just a plugin, not much I can do when called directly.');
}
foreach(glob(plugin_dir_path(__FILE__) . 'classes/*.php') as $ifwp){
    require_once($ifwp);
}
foreach(glob(plugin_dir_path(__FILE__) . 'functions/*.php') as $ifwp){
    require_once($ifwp);
}
$ifwp = ifwp_filesystem();
if(is_wp_error($ifwp)){
    add_action('admin_notices', function() use($ifwp){
        echo ifwp_admin_notice_html('<strong>' . __('Error:') . '</strong> ' . __($ifwp->get_error_message()), 'error');
    });
} else {
	add_action('after_setup_theme', function(){
		IFWP::after_setup_theme();
		$ifwp = get_stylesheet_directory() . '/ifwp-functions.php';
		if(file_exists($ifwp)){
			require_once($ifwp);
		}
		do_action('ifwp_after_setup_theme');
	});
	add_action('plugins_loaded', function(){
		ifwp_build_update_checker('https://plugins.ifwp.co/wp-update-server/?action=get_metadata&slug=ifwp', __FILE__, 'ifwp');
		IFWP::plugins_loaded();
		IFWP\Cloudinary::plugins_loaded();
		do_action('ifwp_plugins_loaded');
	});
}
unset($ifwp);
